
#target Illustrator

//Version 2.10
//Date 171117
//Description: This script is used in Illustrator to Create Layers for cutting. The script also places the Mimaki cropmarks.

var exceptions
var smallestx=999999999999999999;
var smallesty=999999999999999999;
var flpath=$.fileName;
var markpath=flpath.replace("Asanti2Mimaki.js", "mimakimark.ai");
var origpathwidth=0;
var origpaththickness=0;
var ptstomm=0.352778;
var orientationstring="";
var listofmarks=""
var alreadyconverted=0;
var configfile=flpath.replace("Asanti2Mimaki.js", "Asanti2Mimaki_except.txt");

//alert(configfile);
     var file = File(configfile);  
	 if(file != null) {
    file.open("r");  
      
   
    var exceptionsa = file.readln();
    //alert(exceptionsa);
    
	 file.close();  }



var myFile = File.openDialog("Open Asanti cutting file","*.pdf");

if(myFile != null) 
	{
		//Open the file
		app.open(myFile);
		var doc = app.activeDocument;
		
		//Verify if the script didn't run yet on this file
		for (var i = 0, il = doc.layers.length; i < il; i++) {  
			var curLayer = doc.layers[i];  
    
			if (curLayer.name == "Mimaki Register Mark") {  
			alreadyconverted=1
             
			} 
		}  
 
		
		if(alreadyconverted==0){
		
		
		var docwidth=doc.width;
		var docheight=doc.height;
		var paths = doc.pathItems;

		//Create a layer for marks that are not needed for the mimaki
		testa=doc.layers.add("test");
		testa.name="ORIG_Marks";
										
		//loop over all elements in the file			
		for (g=0; g<paths.length;g++)
		{

			try		
				{
					var cname = paths[g].strokeColor.spot.name;
				}
	
			catch(abc)
				{
					var cname = "RegMarks";
				}
	
			try
				{
				
				
								if(cname=="RegMarks")	//all paths without a stroke as spot are suspected to be a mark
									{
											if (paths[g].pathPoints.length==3)
												
												{
													orientationstring=""
													currentposition=paths[g].position[0]+"_"+paths[g].position[1]
												
													
													splitpathAx=paths[g].pathPoints[0].anchor[0]
													splitpathAy=paths[g].pathPoints[0].anchor[1]
													splitpathBx=paths[g].pathPoints[1].anchor[0]
													splitpathBy=paths[g].pathPoints[1].anchor[1]
													splitpathCx=paths[g].pathPoints[2].anchor[0]
													splitpathCy=paths[g].pathPoints[2].anchor[1]
													
													if(splitpathAx==splitpathBx && splitpathBy==splitpathCy)
														{
															ismimakimark=1
														}
														else
															{
																if(splitpathAy==splitpathBy && splitpathBx==splitpathCx)
																{
																	
																	ismimakimark=1
																	
																}
																else
																	ismimakimark=0
																
																
															}
														//alert(ismimakimark)
													if (ismimakimark==1){
													
													if(origpathwidth == 0)
													{
													origpaththickness=paths[g].strokeWidth		//The stroke thickness of a line
													origpathwidth =paths[g].width
													}
												
													if (splitpathAx>splitpathBx) 
														{
															//first line of mark goes to the left
															//orientationstring="L"
															if (splitpathBy>splitpathCy)
																{
																	//second line of mark goes to the Bottom
																	
																	orientationstring="LB"
																}
																else
																	{	
																		//second line of mark goes to the Top
																		orientationstring="LT"
																	}
														}
														
														else	
															{
																if (splitpathAx<splitpathBx) 
																	{
											
																		//first line of mark goes to the Right
																		//orientationstring="R"
																		if (splitpathBy>splitpathCy)
																			{
																				//second line of mark goes to the Bottom
																				orientationstring="RB"
																			}
																			else
																			{	
																				//second line of mark goes to the Top
																				orientationstring="RT"
																			}
																		
																	}
																		else	
																			{
											
																				if (splitpathAy>splitpathBy) 
																					{
																						//first line of mark goes to the bottom
																						orientationstring="B"
																						if (splitpathBx>splitpathCx)
																							{
																								//second line of mark goes to the Left
																								orientationstring="BL"
																							}
																							else
																								{	
																									//second line of mark goes to the Right
																									orientationstring="BR"
																								}
																						
																					}
																						else
																							{
																								if (splitpathAy<splitpathBy) 
																									{
														
																										//first line of mark goes to the top
																										orientationstring="T"
																										if (splitpathBx>splitpathCx)
																											{
																												//second line of mark goes to the Left
																												orientationstring="TL"
																											}
																											else
																												{	
																													//second line of mark goes to the Right
																													orientationstring="TR"
																												}
																									}
										
																										else
																											{
																												orientationstring="U"
																											}
											
																							}
										
																			}
													
															}
															//alert(orientationstring+"_"+currentposition);
															if(listofmarks==""){}else{listofmarks=listofmarks+"_"}
															listofmarks=listofmarks+orientationstring+"_"+currentposition
															
															
															
															}
															
															else
																
																{	var destLayer = doc.layers.getByName ("ORIG_Marks");
										paths[g].move(destLayer, ElementPlacement.PLACEATBEGINNING);}
															
															
															
															
												}

										var destLayer = doc.layers.getByName ("ORIG_Marks");
										paths[g].move(destLayer, ElementPlacement.PLACEATBEGINNING);
												
												
												
										}
										
										else
										{
									
											//alert(cname);
											if(cname!="RegMarks")		//move spot stroke paths to a layer with the name of the spot
												{
												var destLayer = doc.layers.getByName (cname);
												paths[g].move(destLayer, ElementPlacement.PLACEATBEGINNING);
												}
											
									
										}
								}
			catch(ab)
				{
					try
						{
							//alert("1");
							test=doc.layers.add("test");
							test.name=cname;
							var destLayer = doc.layers.getByName (cname);
							paths[g].move(destLayer, ElementPlacement.PLACEATBEGINNING);
						}
					catch(avb)
						{
							alert("it was not possible to convert specific objects to layers. Layer: "+cname+".");
						}
				}

}
				


		//testa.visible=false;		

		try
			{
				
				var doc2 = app.open(File(markpath))
				
				doc2.selectall
				doc2.selectObjectsOnActiveArtboard(); // select all in artboard
				sel = doc2.selection; // get selection
				//moveObjects(sel, doc); // move selection

 for (k=0; k<sel.length; k++) 
 
	{ // duplicate items to the same layer in dest document, give both documents have the same layer structure
        
	try
		{
			
			var test=doc.layers.add("test");
			test.name="Mimaki Register Mark";
	

						
			var myarray = listofmarks.split('_');

			for(var i = 0; i < myarray.length; i++)
{
   
						rt=1
						switch (myarray[i]) {
							case "LT":
								rt=0
								break;
							case "BR":
								rt=0
								break;
							case "RT":
								rt=90
								break;
							case "BL":
								rt=90
								break;
								
							case "RB":
								rt=180
								break;
							case "TL":
								rt=180
								break;
								
							case "LB":
								rt=270
								break;
							case "TR":
								rt=270
								break; 
}
						if(rt==1){}
						else
							
							{
								i++
								smallestx=myarray[i]
								//alert(smallestx)
								i++
								smallesty=myarray[i]
						var newItem = sel[k].duplicate(doc.layers["Mimaki Register Mark"],ElementPlacement.PLACEATEND);
						
						newItem.width=origpathwidth
						newItem.height=origpathwidth
						newItem.strokeWidth=origpaththickness
						
						newItem.position=new Point(Number(smallestx),Number(smallesty));	
						newItem.rotate(rt);
						
						}
						
			}	
					
	}
	catch(ddd)
	{
	alert("It was not possible to place the marks."+ ddd.message+".");
	}
	
	
    }

	
					doc2.close(SaveOptions.DONOTSAVECHANGES);
							}
		catch(err)
			{
				txt="error retreiving file " + markpath + ":\n\n";
				txt+="Error description: " + err.message + "\n\n";
				txt+="Click OK to continue.\n\n";
				alert(txt);
			}



				
	}	
	
	
	
	var myarray = exceptionsa.split(',');

	for(var i = 0; i < myarray.length; i++)
		{
			try
				{
					app.activeDocument.layers.getByName(myarray[i]).remove(); 
				}
			catch(e)
				{}
	
	
		}
		
	try
				{
		app.activeDocument.layers.getByName("ORIG_Marks").visible=false;
	}
			catch(f)
				{}
	
	
	
	
	};
	

